/*
Usage: java EnterNumber

Program with exception handling that uses try, catch, and finally, and includes both a standard and a custom exception.
The program loops infinitely.
*/
import java.io.*;

class NegativeNumberException extends Exception
{
	public NegativeNumberException(String error)
	{
    	super(error);
	}
}

class EnterNumber
{
	public static void main(String args[])
		throws IOException
		{
			BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			int num1, num2;

			for(;;)
			{
				try
				{
					System.out.println("Enter a number: ");
					num1 = Integer.parseInt(br.readLine());
					if (num1 < 0)
						throw new NegativeNumberException("Negative numbers are not permitted.");

					System.out.println("Enter another number: ");
					num2 = Integer.parseInt(br.readLine());
					if (num2 < 0)
						throw new NegativeNumberException("Negative numbers are not permitted.");

					System.out.println(num1 + " * " + num2 + " = " + (num1 * num2));
				}

				catch(NegativeNumberException exc)
				{
					System.out.println(exc);
				}

				catch(NumberFormatException exc)
				{
					System.out.println(exc.getMessage() + ": That's not a number.");
				}

				finally
				{
					System.out.println("Let's do it again!\n");
					continue;
				}
			}
		}
}