/* Copy a text file, substituting hyphens for spaces. This version uses bytes streams.
   Usage: java Hyphen sourceFile targetFile
*/
import java.io.*;

class Hyphen
{
  public static void main(String args[])
    throws Throwable
  {
    String exceptionMsg;
    int i;
    File fileObj;
    FileInputStream fin;
    FileOutputStream fout;

    fin = null;

    try
    {
      // open input file
      try
      {
        fin = new FileInputStream(args[0]);
        System.out.println("It worked!");
      }
      catch(FileNotFoundException exc)
      {
        exceptionMsg = exc.getMessage();
        System.out.println("Message: " + exceptionMsg);
        System.out.println("Input File Not Found");
        exc.printStackTrace();
        //return;
      }
      finally
      {
         System.out.println("Finally...");
      }

      // open output file
      try
      {

        fileObj = new File(args[1]);
        if (fileObj.exists())
          System.out.println("WARNING: File exists and will be overwritten.");

        fout = new FileOutputStream(fileObj, true);
      } catch(FileNotFoundException exc)
      {
        System.out.println("Error Opening Output File");
        return;
      }
    } catch(ArrayIndexOutOfBoundsException exc)
    {
      System.out.println("Usage: Hyphen From To");
      return;
    }

    // Copy File
    try
    {
      for (i=0; i != -1; i = fin.read())
      {
        if((char)i == ' ') i = '-';
        if(i != -1) fout.write(i);

      }
    } catch(IOException exc) {
      System.out.println("File Error");
    }

    i=0;
    while ((i++) < 10)
      System.out.println(i);

    fin.close();
    fout.close();
  }
}