// Write an entire line, rather than each byte one-by-one
import java.io.*;
public class OutputStreamBufferDemo
{
    public void writeToFile(String filename)
    {
        BufferedOutputStream bufferedOutput = null;
        try
        {
            bufferedOutput = new BufferedOutputStream(new FileOutputStream(filename));

            bufferedOutput.write("Line one".getBytes());
            bufferedOutput.write("\n".getBytes()); //new line, you might want to use \r\n if you're on Windows
            bufferedOutput.write("Line two".getBytes());
            bufferedOutput.write("\n".getBytes());

            //prints the character that has the decimal value of 65
            bufferedOutput.write(65);
            bufferedOutput.write(65 + 32);

        }
        catch(FileNotFoundException ex)
        {
            ex.printStackTrace();
        }
        catch(IOException ex)
        {
            ex.printStackTrace();
        }
        finally
        {
            //Close the BufferedOutputStream
            try
            {
                if (bufferedOutput != null)
                {
                    bufferedOutput.flush();
                    bufferedOutput.close();
                }
            }
            catch (IOException ex)
            {
                ex.printStackTrace();
            }
        }
    }

    public static void main(String[] args)
    {
        // call a non-static method without naming my object
        new OutputStreamBufferDemo().writeToFile("myFile.txt");
    }
}