// This version allows the garbage collector to close the FileInputStream when it goes out of scope, that is, when we are not longer in the try block.
// Usage: java ShowFileTryWithResources myFile.txt
import java.io.*;
public class ShowFileTryWithResources
{
  public static void main(String[] args)
    throws IOException
  {
    int i;
    // FileInputStream fin;
    try(FileInputStream fin = new FileInputStream(args[0]))
    {
      //fin = new FileInputStream(args[0]);
	  // read bytes until EOF is encountered
	  do
	  {
		i = fin.read();
		if(i != -1) System.out.print((char) i);
	  }
      while(i != -1);
    }
    catch(FileNotFoundException exc)
    {
      System.out.println("File Not Found");
      return;
    }
   catch(ArrayIndexOutOfBoundsException exc)
	{
	  System.out.println("Error: " + exc.toString());
	  System.out.println("Usage: java ShowFile FileName");
	  return;
    }
    // fin.close(); // fin will be garbage collected automatically
    System.out.println("\nNow we are done printing the file!!!!");
  }
}