import java.io.*;
import java.util.*;
import java.util.zip.*;

class TryWithResourceOnZipFile
{
	public static void writeToFileZipFileContents(String zipFileName,
											   String outputFileName)
											   throws IOException
	{
		java.nio.charset.Charset charset =
			 java.nio.charset.StandardCharsets.US_ASCII;
		// get a file system path from the file name string
		java.nio.file.Path outputFilePath =
			 java.nio.file.Paths.get(outputFileName);

		// Open zip file and the create output file within
		// try-with-resources statement
		try(
			ZipFile zf =
				 new ZipFile(zipFileName);
			BufferedWriter writer =
				java.nio.file.Files.newBufferedWriter(outputFilePath, charset))
		{
			// Enumerate each entry - note no increment in for
			// and note that java.util.Enumeration is an interface
			for(Enumeration entries =
									zf.entries();
									entries.hasMoreElements();)
			{
				// Get the entry name and write it to the output file
				String newLine = System.getProperty("line.separator");
				String zipEntryName =
					 ((ZipEntry)entries.nextElement()).getName() +
					 newLine;
				writer.write(zipEntryName, 0, zipEntryName.length());
			}
		}
		catch(IOException e) { e.toString(); }
	}
	public static void main(String[] args) throws IOException
	{
        writeToFileZipFileContents("io-examples-fall-2012-b.zip", "zip-contains.txt");
        System.out.println("This program can now do other things.");
	}
}